;CodeVisionAVR C Compiler V1.24.0 Standard
;(C) Copyright 1998-2003 HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : ATtiny26
;Clock frequency     : 8,000000 MHz
;Memory model        : Tiny
;Optimize for        : Size
;(s)printf features  : int, width
;(s)scanf features   : long, width
;External SRAM size  : 0
;Data Stack size     : 30 byte(s)
;Heap size           : 0 byte(s)
;Promote char to int : Yes
;char is unsigned    : Yes
;8 bit enums         : Yes
;Automatic register allocation : On

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU SPL=0x3D
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x20
	.EQU __sm_mask=0x18
	.EQU __sm_powerdown=0x10

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	CLR  R30
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOV  R30,R0
	MOV  R31,R1
	.ENDM

	.MACRO __GETB2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOV  R26,R0
	MOV  R27,R1
	.ENDM

	.MACRO __GETBRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "tstI2Csl.vec"
	.INCLUDE "tstI2Csl.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	LDI  R31,0x10
	OUT  WDTCR,R31

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x80)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM
	ADIW R30,1
	MOV  R1,R0
	LPM
	ADIW R30,1
	MOV  R22,R30
	MOV  R23,R31
	MOV  R31,R0
	MOV  R30,R1
	SBIW R30,0
	BREQ __GLOBAL_INI_END
	LPM
	ADIW R30,1
	MOV  R26,R0
	LPM
	ADIW R30,1
	MOV  R27,R0
	LPM
	ADIW R30,1
	MOV  R24,R0
	LPM
	ADIW R30,1
	MOV  R25,R0
__GLOBAL_INI_LOOP:
	LPM
	ADIW R30,1
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOV  R30,R22
	MOV  R31,R23
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0xDF)
	OUT  SPL,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x7E)
	LDI  R29,HIGH(0x7E)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x7E
;       1 /*****************************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V2.03.8a Evaluation
;       4 Automatic Program Generator
;       5  Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;       6 http://www.hpinfotech.com
;       7 
;       8 Project : Robot suiveur de ligne
;       9 Sous Projet : Test de la gestion I2C d'un afficheur
;      10 Version : 1
;      11 Date    : 24/02/2009
;      12 Author  : Freeware, for evaluation and non-commercial use only
;      13 Company :  Lyce Pierre Emile Martin 1, Av de Gionne 18000 BOURGES
;      14 Comments:  Rception des caractres  envoyer sur l'afficheur par la
;      15            liaison I2C (USI) et affichage 
;      16 
;      17 Chip type           : ATtiny26
;      18 Clock frequency     : 8,000000 MHz (Oscillateur interne)
;      19 Memory model        : Tiny
;      20 External RAM size   : 0
;      21 Data Stack size     : 32
;      22 *****************************************************/
;      23 
;      24 #include <tiny26.h>
;      25 //#include <delay.h>    // contient la fonction delay_ms
;      26 //#include <stdio.h>    // contient la fonction sprintf
;      27 
;      28 #include "USI_TWI_Slave.h"
;      29 
;      30 // Sample TWI transmission commands
;      31 #define TWI_CMD_MASTER_WRITE 0x10
;      32 #define TWI_CMD_MASTER_READ  0x20
;      33 #define TWI_CMD_MASTER_WRITE_ALOT 0x30
;      34 
;      35 // Alphanumeric LCD Module functions
;      36 //#asm
;      37 //   .equ __lcd_port=0x1B ;PORTA
;      38 //#endasm
;      39 //#include <lcd.h>
;      40 
;      41 
;      42 // Declare your global variables here
;      43 
;      44 
;      45 void main(void)
;      46 {

	.CSEG
_main:
;      47 // -----------------------------------------------------------------------------------------------------
;      48 // Declare your global variables here  
;      49 //-------------------------------------------------------------------------------------------------------
;      50 // type 	nom              				Description
;      51 //-------------------------------------------------------------------------------------------------------
;      52 //char display_buffer_ligne0[17]; 			// tampon ligne 0 de l'afficheur
;      53 //char display_buffer_ligne1[17]; 			// tampon ligne 1 de l'afficheur
;      54 
;      55 unsigned char TWI_slaveAddress, temp;
;      56  
;      57 // Input/Output Ports initialization
;      58 // Port A initialization
;      59 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
;      60 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
;      61 PORTA=0x00;
;	TWI_slaveAddress -> R16
;	temp -> R17
	CLR  R30
	OUT  0x1B,R30
;      62 DDRA=0x00;
	OUT  0x1A,R30
;      63 
;      64 // Port B initialization
;      65 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
;      66 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
;      67 PORTB=0x00;
	OUT  0x18,R30
;      68 DDRB=0x00;
	OUT  0x17,R30
;      69 
;      70 
;      71 // Universal Serial Interface initialization
;      72 // Mode: Two Wire (I2C)
;      73 // Clock source: Register & Counter=no clk.
;      74 // USI Counter Overflow Interrupt: On
;      75 // USI Start Condition Interrupt: On
;      76 USICR=0xE0;
	LDI  R30,LOW(224)
	OUT  0xD,R30
;      77 
;      78 
;      79 // LCD module initialization
;      80 //lcd_init(16);
;      81 
;      82 // Own TWI slave address
;      83   TWI_slaveAddress = 0x10;
	LDI  R16,LOW(16)
;      84   USI_TWI_Slave_Initialise( TWI_slaveAddress );
	ST   -Y,R16
	RCALL _USI_TWI_Slave_Initialise
;      85 
;      86 // Global enable interrupts
;      87 #asm("sei")
	sei
;      88 
;      89 //lcd_clear();
;      90 //sprintf(display_buffer_ligne0,"   Test I2C Rx  ");
;      91 //sprintf(display_buffer_ligne1,"----------------");
;      92 //lcd_puts(display_buffer_ligne0);
;      93 //lcd_gotoxy(0,1);
;      94 //lcd_puts(display_buffer_ligne1);
;      95 //delay_ms(3000);
;      96 //lcd_clear();
;      97 
;      98  // This loop runs forever. If the TWI Transceiver is busy the execution will just continue doing other operations.
;      99  for(;;)
_0x8:
;     100   {
;     101 
;     102     if( USI_TWI_Data_In_Receive_Buffer() )
	RCALL _USI_TWI_Data_In_Receive_Buffer
	CPI  R30,0
	BREQ _0xA
;     103     {
;     104         temp = USI_TWI_Receive_Byte();
	RCALL _USI_TWI_Receive_Byte
	MOV  R17,R30
;     105         PORTB = temp;
	OUT  0x18,R17
;     106         USI_TWI_Transmit_Byte(temp);
	ST   -Y,R17
	RCALL _USI_TWI_Transmit_Byte
;     107     }
;     108 
;     109     // Do something else while waiting for the TWI transceiver to complete.
;     110     // Put own code here.
;     111   }
_0xA:
	RJMP _0x8
;     112 }
_0xB:
	RJMP _0xB
;     113 
;     114 /*! \mainpage
;     115  * \section Intro Introduction
;     116  * This documents data structures, functions, variables, defines, enums, and
;     117  * typedefs in the software for application note AVR312.
;     118  *
;     119  * \section CI Compilation Info
;     120  * This software was written for the IAR Embedded Workbench 4.11A.
;     121  *
;     122  * To make project:
;     123  * <ol>
;     124  * <li> Add the file main.c and USI_TWI_Slave to project.
;     125  * <li> Under processor configuration, select any AVR device with USI module.
;     126  * <li> Enable bit definitions in I/O include files
;     127  * <li> High optimization on size is recommended for lower code size.
;     128  * </ol>
;     129  *
;     130  * \section DI Device Info
;     131  * The included source code is written for all devices with with a USI module.
;     132  *
;     133  * \section TS Target setup
;     134  * This example is made to work together with the AVR310 USI TWI Master application note. In adition to connecting the TWI
;     135  * pins, also connect PORTB to the LEDS. The code reads a message as a TWI slave and acts according to if it is a
;     136  * general call, or an address call. If it is an address call, then the first byte is considered a command byte and
;     137  * it then responds differently according to the commands.
;     138  *
;     139  */
;     140 
;     141 

	.DSEG
_TWI_slaveAddress_G2:
	.BYTE 0x1
_USI_TWI_Overflow_State_G2:
	.BYTE 0x1
_TWI_RxBuf_G2:
	.BYTE 0x10
_TWI_RxHead_G2:
	.BYTE 0x1
_TWI_RxTail_G2:
	.BYTE 0x1
_TWI_TxBuf_G2:
	.BYTE 0x10
_TWI_TxHead_G2:
	.BYTE 0x1
_TWI_TxTail_G2:
	.BYTE 0x1

	.CSEG
_Flush_TWI_Buffers:
	CLR  R30
	STS  _TWI_RxTail_G2,R30
	STS  _TWI_RxHead_G2,R30
	STS  _TWI_TxTail_G2,R30
	STS  _TWI_TxHead_G2,R30
	RET
_USI_TWI_Slave_Initialise:
	RCALL _Flush_TWI_Buffers
	LD   R30,Y
	STS  _TWI_slaveAddress_G2,R30
	IN   R30,0x18
	PUSH R30
	CLR  R30
	SBIC 0x18,2
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	RCALL SUBOPT_0x1
	IN   R30,0x18
	PUSH R30
	CLR  R30
	SBIC 0x18,0
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	RCALL SUBOPT_0x1
	IN   R30,0x17
	PUSH R30
	CLR  R30
	SBIC 0x18,2
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	RCALL SUBOPT_0x2
	IN   R30,0x17
	PUSH R30
	CLR  R30
	SBIC 0x18,0
	LDI  R30,1
	RCALL SUBOPT_0x0
	COM  R30
	POP  R26
	RCALL SUBOPT_0x3
	CLR  R30
	SBIC 0xD,7
	LDI  R30,1
	RCALL SUBOPT_0x0
	PUSH R30
	CLR  R30
	SBIC 0xD,6
	LDI  R30,1
	RCALL SUBOPT_0x4
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xD,5
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xD,4
	LDI  R30,1
	RCALL SUBOPT_0x4
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xD,3
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xD,2
	LDI  R30,1
	RCALL SUBOPT_0x4
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xD,1
	LDI  R30,1
	RCALL SUBOPT_0x4
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xD,0
	LDI  R30,1
	RCALL SUBOPT_0x4
	POP  R26
	RCALL SUBOPT_0x5
	LDI  R30,LOW(240)
	OUT  0xE,R30
	ADIW R28,1
	RET
_USI_TWI_Transmit_Byte:
	ST   -Y,R16
	LDS  R30,_TWI_TxHead_G2
	RCALL SUBOPT_0x6
_0x14:
	LDS  R30,_TWI_TxTail_G2
	CP   R30,R16
	BREQ _0x14
	MOV  R30,R16
	SUBI R30,-LOW(_TWI_TxBuf_G2)
	MOV  R26,R30
	LDD  R30,Y+1
	ST   X,R30
	STS  _TWI_TxHead_G2,R16
	LDD  R16,Y+0
	ADIW R28,2
	RET
_USI_TWI_Receive_Byte:
	RCALL __SAVELOCR2
	LDS  R17,_TWI_RxTail_G2
_0x18:
	LDS  R26,_TWI_RxHead_G2
	CP   R17,R26
	BREQ _0x18
	LDS  R30,_TWI_RxTail_G2
	RCALL SUBOPT_0x6
	STS  _TWI_RxTail_G2,R16
	LDI  R26,LOW(_TWI_RxBuf_G2)
	ADD  R26,R16
	LD   R30,X
	RCALL __LOADLOCR2P
	RET
_USI_TWI_Data_In_Receive_Buffer:
	ST   -Y,R16
	LDS  R16,_TWI_RxTail_G2
	MOV  R30,R16
	LDS  R26,_TWI_RxHead_G2
	RCALL __NEB12
	LD   R16,Y+
	RET
_usi_start_isr:
	RCALL __SAVEISR
	ST   -Y,R16
	IN   R16,14
	CLR  R30
	RCALL SUBOPT_0x7
	PUSH R30
	CLR  R30
	SBIC 0x18,0
	LDI  R30,1
	RCALL SUBOPT_0x0
	COM  R30
	POP  R26
	RCALL SUBOPT_0x3
_0x1D:
	IN   R30,0x16
	PUSH R30
	CLR  R30
	SBIC 0x18,2
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	AND  R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xE,5
	LDI  R30,1
	RCALL SUBOPT_0x0
	AND  R30,R16
	RCALL __LNEGB1
	POP  R26
	AND  R30,R26
	BRNE _0x1D
	CLR  R30
	SBIC 0xD,7
	LDI  R30,1
	RCALL SUBOPT_0x0
	PUSH R30
	CLR  R30
	SBIC 0xD,6
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xD,5
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xD,4
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xD,3
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xD,2
	LDI  R30,1
	RCALL SUBOPT_0x4
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xD,1
	LDI  R30,1
	RCALL SUBOPT_0x4
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xD,0
	LDI  R30,1
	RCALL SUBOPT_0x4
	POP  R26
	RCALL SUBOPT_0x5
	CLR  R30
	SBIC 0xE,7
	LDI  R30,1
	RCALL SUBOPT_0x0
	PUSH R30
	CLR  R30
	SBIC 0xE,6
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xE,5
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xE,4
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xE,0
	LDI  R30,1
	RCALL SUBOPT_0x4
	POP  R26
	RCALL SUBOPT_0x8
	LD   R16,Y+
	RCALL __LOADISR
	RETI
_usi_ovf_isr:
	RCALL __SAVEISR
	RCALL __SAVELOCR2
	LDS  R30,_USI_TWI_Overflow_State_G2
	CLR  R31
	SBIW R30,0
	BREQ PC+2
	RJMP _0x24
	RCALL SUBOPT_0x9
	BREQ _0x26
	IN   R30,0xF
	LSR  R30
	LDS  R26,_TWI_slaveAddress_G2
	CP   R30,R26
	BRNE _0x25
_0x26:
	SBIS 0xF,0
	RJMP _0x28
	LDI  R30,LOW(1)
	RJMP _0x35
_0x28:
	LDI  R30,LOW(4)
_0x35:
	STS  _USI_TWI_Overflow_State_G2,R30
	RCALL SUBOPT_0xA
	IN   R30,0x17
	PUSH R30
	CLR  R30
	SBIC 0x18,0
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	RCALL SUBOPT_0x2
	CLR  R30
	SBIC 0xE,7
	LDI  R30,1
	RCALL SUBOPT_0x4
	PUSH R30
	CLR  R30
	SBIC 0xE,6
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xE,5
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xE,4
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xE,0
	LDI  R30,1
	RCALL SUBOPT_0xB
	POP  R26
	RJMP _0x36
_0x25:
	CLR  R30
	SBIC 0xD,7
	LDI  R30,1
	RCALL SUBOPT_0x0
	PUSH R30
	CLR  R30
	SBIC 0xD,6
	LDI  R30,1
	RCALL SUBOPT_0x4
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xD,5
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xD,4
	LDI  R30,1
	RCALL SUBOPT_0x4
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xD,3
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xD,2
	LDI  R30,1
	RCALL SUBOPT_0x4
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xD,1
	LDI  R30,1
	RCALL SUBOPT_0x4
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xD,0
	LDI  R30,1
	RCALL SUBOPT_0x4
	POP  R26
	RCALL SUBOPT_0x5
	CLR  R30
	SBIC 0xE,7
	LDI  R30,1
	RCALL SUBOPT_0x4
	PUSH R30
	CLR  R30
	SBIC 0xE,6
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xE,5
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xE,4
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xE,0
	LDI  R30,1
	RCALL SUBOPT_0x4
	POP  R26
_0x36:
	OR   R30,R26
	OUT  0xE,R30
	RJMP _0x23
_0x24:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x2B
	RCALL SUBOPT_0x9
	BRNE PC+2
	RJMP _0x2C
	CLR  R30
	SBIC 0xD,7
	LDI  R30,1
	RCALL SUBOPT_0x0
	PUSH R30
	CLR  R30
	SBIC 0xD,6
	LDI  R30,1
	RCALL SUBOPT_0x4
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xD,5
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xD,4
	LDI  R30,1
	RCALL SUBOPT_0x4
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xD,3
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xD,2
	LDI  R30,1
	RCALL SUBOPT_0x4
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xD,1
	LDI  R30,1
	RCALL SUBOPT_0x4
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xD,0
	LDI  R30,1
	RCALL SUBOPT_0x4
	POP  R26
	RCALL SUBOPT_0x5
	CLR  R30
	SBIC 0xE,7
	LDI  R30,1
	RCALL SUBOPT_0x4
	PUSH R30
	CLR  R30
	SBIC 0xE,6
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xE,5
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xE,4
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xE,0
	LDI  R30,1
	RCALL SUBOPT_0x4
	POP  R26
	RCALL SUBOPT_0x8
	RJMP _0x34
_0x2C:
	RJMP _0x2D
_0x2B:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x2E
_0x2D:
	LDS  R16,_TWI_TxTail_G2
	LDS  R26,_TWI_TxHead_G2
	CP   R16,R26
	BREQ _0x2F
	LDS  R30,_TWI_TxTail_G2
	RCALL SUBOPT_0xC
	STS  _TWI_TxTail_G2,R30
	SUBI R30,-LOW(_TWI_TxBuf_G2)
	LD   R30,Z
	OUT  0xF,R30
	RJMP _0x30
_0x2F:
	CLR  R30
	SBIC 0xD,7
	LDI  R30,1
	RCALL SUBOPT_0x0
	PUSH R30
	CLR  R30
	SBIC 0xD,6
	LDI  R30,1
	RCALL SUBOPT_0x4
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xD,5
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xD,4
	LDI  R30,1
	RCALL SUBOPT_0x4
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xD,3
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xD,2
	LDI  R30,1
	RCALL SUBOPT_0x4
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xD,1
	LDI  R30,1
	RCALL SUBOPT_0x4
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xD,0
	LDI  R30,1
	RCALL SUBOPT_0x4
	POP  R26
	RCALL SUBOPT_0x5
	CLR  R30
	SBIC 0xE,7
	LDI  R30,1
	RCALL SUBOPT_0x4
	PUSH R30
	CLR  R30
	SBIC 0xE,6
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xE,5
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xE,4
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xE,0
	LDI  R30,1
	RCALL SUBOPT_0x4
	POP  R26
	RCALL SUBOPT_0x8
	RJMP _0x34
_0x30:
	LDI  R30,LOW(2)
	RCALL SUBOPT_0x7
	PUSH R30
	CLR  R30
	SBIC 0x18,0
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	RCALL SUBOPT_0x2
	CLR  R30
	SBIC 0xE,7
	LDI  R30,1
	RCALL SUBOPT_0x4
	PUSH R30
	CLR  R30
	SBIC 0xE,6
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xE,5
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xE,4
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xE,0
	LDI  R30,1
	RCALL SUBOPT_0x4
	POP  R26
	RCALL SUBOPT_0x8
	RJMP _0x23
_0x2E:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x31
	LDI  R30,LOW(3)
	RCALL SUBOPT_0x7
	PUSH R30
	CLR  R30
	SBIC 0x18,0
	LDI  R30,1
	RCALL SUBOPT_0x0
	COM  R30
	POP  R26
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0xA
	CLR  R30
	SBIC 0xE,7
	LDI  R30,1
	RCALL SUBOPT_0x4
	PUSH R30
	CLR  R30
	SBIC 0xE,6
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xE,5
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xE,4
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xE,0
	LDI  R30,1
	RCALL SUBOPT_0xB
	POP  R26
	RCALL SUBOPT_0x8
	RJMP _0x23
_0x31:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x32
	LDI  R30,LOW(5)
	RCALL SUBOPT_0x7
	PUSH R30
	CLR  R30
	SBIC 0x18,0
	LDI  R30,1
	RCALL SUBOPT_0x0
	COM  R30
	POP  R26
	RCALL SUBOPT_0x3
	CLR  R30
	SBIC 0xE,7
	LDI  R30,1
	RCALL SUBOPT_0x4
	PUSH R30
	CLR  R30
	SBIC 0xE,6
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xE,5
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xE,4
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xE,0
	LDI  R30,1
	RCALL SUBOPT_0x4
	POP  R26
	RCALL SUBOPT_0x8
	RJMP _0x23
_0x32:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0x23
	IN   R17,15
	LDS  R30,_TWI_RxHead_G2
	RCALL SUBOPT_0xC
	STS  _TWI_RxHead_G2,R30
	SUBI R30,-LOW(_TWI_RxBuf_G2)
	MOV  R26,R30
	ST   X,R17
	LDI  R30,LOW(4)
	STS  _USI_TWI_Overflow_State_G2,R30
	RCALL SUBOPT_0xA
	IN   R30,0x17
	PUSH R30
	CLR  R30
	SBIC 0x18,0
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	RCALL SUBOPT_0x2
	CLR  R30
	SBIC 0xE,7
	LDI  R30,1
	RCALL SUBOPT_0x4
	PUSH R30
	CLR  R30
	SBIC 0xE,6
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xE,5
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xE,4
	LDI  R30,1
	RCALL SUBOPT_0x0
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIC 0xE,0
	LDI  R30,1
	RCALL SUBOPT_0xB
	POP  R26
	RCALL SUBOPT_0x8
_0x23:
_0x34:
	RCALL __LOADLOCR2P
	RCALL __LOADISR
	RETI

;OPTIMIZER ADDED SUBROUTINE, CALLED 57 TIMES
SUBOPT_0x0:
	LDI  R26,LOW(1)
	RCALL __LSLB12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1:
	OR   R30,R26
	OUT  0x18,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x2:
	OR   R30,R26
	OUT  0x17,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x3:
	AND  R30,R26
	OUT  0x17,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 37 TIMES
SUBOPT_0x4:
	CLR  R26
	RCALL __LSLB12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x5:
	OR   R30,R26
	OUT  0xD,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x6:
	SUBI R30,-LOW(1)
	ANDI R30,LOW(0xF)
	MOV  R16,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x7:
	STS  _USI_TWI_Overflow_State_G2,R30
	IN   R30,0x17
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0x8:
	OR   R30,R26
	OUT  0xE,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x9:
	IN   R30,0xF
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0xA:
	CLR  R30
	OUT  0xF,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0xB:
	LDI  R26,LOW(14)
	RCALL __LSLB12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xC:
	SUBI R30,-LOW(1)
	ANDI R30,LOW(0xF)
	RET

__SAVEISR:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R0,SREG
	ST   -Y,R0
	RET

__LOADISR:
	LD   R0,Y+
	OUT  SREG,R0
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RET

__LSLB12:
	TST  R30
	MOV  R0,R30
	MOV  R30,R26
	BREQ __LSLB12R
__LSLB12L:
	LSL  R30
	DEC  R0
	BRNE __LSLB12L
__LSLB12R:
	RET

__NEB12:
	CP   R30,R26
	LDI  R30,1
	BRNE __NEB12T
	CLR  R30
__NEB12T:
	RET

__LNEGB1:
	TST  R30
	LDI  R30,1
	BREQ __LNEGB1F
	CLR  R30
__LNEGB1F:
	RET

__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR2P:
	LD   R16,Y+
	LD   R17,Y+
	RET

